# -*- coding: utf-8 -*-
"""
Created on Mon May 22 16:45:19 2017

@author: hector
"""

import avro.schema
from avro.io import DatumReader, DatumWriter, BinaryEncoder, BinaryDecoder
import io
import sys


# by indicating here the expected names we force both the completeness
#  of the schema set and the expected names
messageTypes=["StatusRequest",
         "SensorStatus",
         "SensorInfo",
         "MeasurementCommand",
         "Log",
         "GroupConfiguration"]
avroschema=None
         
def init(config):
  global avroSchema
  try:
    avroSchema=avro.schema.Parse(
    open(config["path"], "r").read() )
  except SchemaParseException as err:
    print ("Schema could not be read from %s. Check AVRO path option."  % 
        (config["path"]) )
    print(err)
    sys.exit(1)
  
def decodeAvroMessage(msg):
    global avroSchema
    buf=io.BytesIO(msg)
    decoder=BinaryDecoder(buf)
    reader=DatumReader(avroSchema)
    try:
        r=reader.read(decoder)
    except:
        buf.close()
        return {}
    buf.close()  # dirty FIXME TODO
    return r
    
# Create an AVRO byte message
def createAVROMessage(messageType, data):
    """Create an Avro record with fields type = messageType and message = data 
    Encapsulation ensures that the decoder can infer the schema based on the `type` field
    """
    global schema
    buf=io.BytesIO()
    encoder=BinaryEncoder(buf)
    writer = DatumWriter(avroSchema)
    writer.write({"Type":messageType, "Message":data}, encoder)
    msg=bytearray(buf.getvalue())
    buf.close()
    return msg
